SystemOrganization addCategory: #'MC2-Tests-Serialization'!

TestCase subclass: #MDMaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDMaterializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:04'!
isAbstract
	^ self name = #MDMaterializerTest! !

MDMaterializerTest subclass: #MDUtf8MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 12:30'!
assert: aByteArray yields: expected
	| actual |
	actual := SMMaterializer materialize: aByteArray.
	self assert: actual = expected! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/2/2009 23:41'!
testAboriginal
	self
		assert: #(15 9 3 225 144 129 225 144 130 225 144 131)
		yields: (MDPlatform current stringFromUnicode: #(16r1401 16r1402 16r1403))! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:36'!
testAscii
	self
		assert: #(15 9 3 97 98 99)
		yields: 'abc'! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/2/2009 23:44'!
testLatin
	self
		assert: #(15 9 3 195 161 98 99)
		yields: (MDPlatform current stringFromUnicode: #(225 98 99))! !

TestCase subclass: #MDSerializationBytesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDSerializationBytesTest methodsFor: 'asserting' stamp: 'cwp 8/23/2010 11:41'!
assert: anObject serializesTo: anArray 
	| expected actual |
	actual := SMSerializer serialize: anObject.
	expected := anArray asByteArray.
	self assert: actual = expected! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testDefinitionVariant
	| definition |
	definition := MDTestBuilder new definition.
 	self assert: definition serializesTo: #(1 5 9 2 1 5 9 8 14 9 5 65 108 112 104 97 20 9 0)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:03'!
testFakeElement
| element |
	element := MDTestBuilder new element.
	self assert: element serializesTo: #(1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/9/2009 01:14'!
testHashstamp
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: #(125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62) asByteArray
		timestamp: (MDTimestamp fromInteger: 905800829).
	self 
		assert: hashstamp 
		serializesTo: #(22 53 253 108 125 125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62 31)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/23/2010 11:41'!
testMemo
	| memo |
	memo := MDTestBuilder new memo.
	memo instVarAt: 1 put: (MDHashstamp fromString: 'BTpiEUqnmCG0M-vpGmAqClg7Epiwyh+k').
	memo instVarAt: 2 put: (MDHashstamp fromString: 'BTpifCLy1McVFvfIDx7ZkWv5YA5quh3d').
	memo instVarAt: 5 put: (MDHashstamp fromString: 'Bq-Yoy3kfy4i+GisbhjJr6tIIPB7lHFr').
	SMSerializer serialize: memo.
	self 
		assert: memo 
		serializesTo: #[23 5 9 7 22 53 253 110 66 13 179 200 228 130 96 30 245 75 35 54 59 27 9 67 91 188 250 208 48 22 53 253 110 172 229 254 13 138 33 71 186 212 63 210 101 194 46 199 144 193 246 234 209 105 1 2 14 9 10 77 68 65 110 99 101 115 116 114 121 9 2 15 9 7 112 97 114 101 110 116 115 15 9 9 97 110 99 101 115 116 111 114 115 17 9 0 18 9 0 20 9 2 14 9 2 105 100 14 9 3 97 98 99 14 9 9 115 108 105 99 101 78 97 109 101 15 9 9 84 101 115 116 83 108 105 99 101 22 55 96 100 211 225 112 175 225 174 1 43 184 158 219 213 220 142 84 81 179 73 197 52 119]! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:37'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new
		first: 1;
		second: 'two';
		yourself.

	self
		assert: properties
		serializesTo: #(20 9 2 14 9 5 102 105 114 115 116 9 1 
					14 9 6 115 101 99 111 110 100 15 9 3 116 
					119 111)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testRemovalVariant
| removal |
	removal := MDTestBuilder new removal.
	self assert: removal serializesTo: #(1 5 9 3 1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/17/2010 10:07'!
testSnapshot
| contents snapshot |
	contents := #('BTploHISPGtEjxw7iNSRzI4sPrBSpkcx' 'BTploIM6Z+ffONzz9IfyCOaH7I8zZPk-') 
		collect: [:ea | MDHashstamp fromString: ea].
	snapshot := MDSnapshot new.
	snapshot instVarAt: 1 put: (MDTimestamp fromInteger: 905802042).
	snapshot instVarAt: 2 put: contents.

	self 
		assert: snapshot
		serializesTo: 
			#[23 5 9 6 21 53 253 113 58 17 9 2 22 53 253 113 209 53 30
			109 46 80 191 223 9 185 151 157 253 65 184 111 115 94 215 
			10 61 22 53 253 113 209 70 8 148 10 235 105 159 255 45 74
			254 57 169 147 37 66 191 149 188 1 6]! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:58'!
testTimestamp
	| ts |
	ts := MDTimestamp fromInteger: 905803057.
	self assert: ts serializesTo: #(21 53 253 117 49)	! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 2/2/2010 20:40'!
testVersion
	| version |
	version := MDTestBuilder new version.
	version instVarAt: 1 put: (MDTimestamp fromInteger: 905803456).
	self 
		assert: version
		serializesTo: #[23 5 9 5 21 53 253 118 192 1 5 9 2 1 5 9 8 14 9 5 65 108 112 104 97 20 9 0 1 2 14 9 10 77 68 65 110 99 101 115 116 114 121 9 2 15 9 7 112 97 114 101 110 116 115 15 9 9 97 110 99 101 115 116 111 114 115 17 9 0 18 9 0]! !

TestCase subclass: #MDSerializationClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDSerializationClassTest commentStamp: 'cwp 4/19/2008 14:31' prior: 0!
This suite of tests ensures that well-known classes are serialized using these class ids:

	    -- core --
	 1  MDSliceElement
	 2  MDDefinitionVariant
	 3  MDRemovalVariant
	 4  MDNullVersion
	 5  MDElementVersion
	 6  MDSnapshot
	 7  MDMemo

	     -- testing --
	 8  MDFakeElement

	    -- smalltalk --
	 9  MDClassElement
	10  MDClassCommentElement
	11  MDInstVarElement
	12  MDClassVarElement
	13  MDClassInstVarElement
	14  MDMethodElement

!

!MDSerializationClassTest methodsFor: 'asserting' stamp: 'cwp 8/23/2010 11:41'!
assert: anObject hasClassId: anInteger
	| bytes |
	bytes := SMSerializer serialize: anObject.
	self assert: (#(1 23) includes: bytes first).	"type object"
	self assert: bytes second = 5.					"well-known class"
	self assert: bytes third = 9.					"byte integer"
	self assert: bytes fourth = anInteger! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'jf 11/8/2009 19:49'!
test02DefinitionVariant
	self 
		assert: MDDefinitionVariant forTesting
		hasClassId: 2! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'jf 11/8/2009 19:49'!
test03RemovalVariant
	self 
		assert: MDRemovalVariant forTesting
		hasClassId: 3! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:17'!
test04NullVersion
	self 
		assert: MDNullVersion new
		hasClassId: 4! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:23'!
test05ElementVersion
	self 
		assert: MDElementVersion new
		hasClassId: 5! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:23'!
test06Snapshot
	self 
		assert: MDSnapshot new
		hasClassId: 6! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:24'!
test07Memo
	self 
		assert: MDMemo new
		hasClassId: 7! !

!MDSerializationClassTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 14:25'!
test08FakeElement
	self 
		assert: MDFakeElement new
		hasClassId: 8! !

TestCase subclass: #MDSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/4/2005 17:39'!
assertEqualityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after = before]! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/23/2010 12:30'!
assertEqualityOf: anObject using: aBlock 
	| other buffer |
	buffer := SMSerializer serialize: anObject.
	other := SMMaterializer materialize: buffer.
	aBlock value: anObject value: other! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/2/2008 11:04'!
assertIdentityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after == before]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:13'!
testArray
	self assertEqualityOf: #(1 2 3)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:02'!
testBytesObject
	self assertEqualityOf: #(1 2 3) asByteArray! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:45'!
testClass
	self assertIdentityOf: self class! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testDefinitionVariant
	self assertEqualityOf: self builder definition! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:29'!
testDictionary
	| dict |
	dict := Dictionary new
			at: #a put: 1;
			at: #b put: 2;
			yourself.
	self assertEqualityOf: dict! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:05'!
testFakeElement
	self assertEqualityOf: self builder element! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testFalse
	self assertIdentityOf: false ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 8/8/2009 17:30'!
testHashstamp
	self assertEqualityOf: MDHashstamp new! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:06'!
testMemo
	self assertEqualityOf: self builder memo! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/23/2008 13:22'!
testMultiString
	| ws |
	ws := MDPlatform current wideString.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testNegativeLargeInteger
	self assertEqualityOf: SmallInteger minVal - 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 02:03'!
testNegativeOneByteInteger
	self assertEqualityOf: -3! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:20'!
testNegativeTwoByteInteger
	self assertEqualityOf: -300! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:05'!
testNil
	self assertIdentityOf: nil! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:27'!
testOneByteInteger
	self assertEqualityOf: 7! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:06'!
testPointersObject
	self assertEqualityOf: MDPlatform current variablePointersObject ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testPositiveLargeInteger
	self assertEqualityOf: SmallInteger maxVal + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new.
	properties
		first: 1;
		second: 'two'.
	self assertEqualityOf: properties! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 9/9/2010 22:46'!
testRemovalVariant
	self assertEqualityOf: self builder removal! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:25'!
testSet
	self assertEqualityOf: #(1 2 3) asSet! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:08'!
testSnapshot
	self assertEqualityOf: self builder snapshot! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/4/2005 17:22'!
testString
	self assertEqualityOf: 'abc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 4/15/2008 21:40'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:15'!
testSymbol
	self assertEqualityOf: #one using: [:before :after | self assert: before == after]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/5/2008 22:29'!
testThreeByteInteger
	self assertEqualityOf: (2 raisedTo: 16) + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 8/23/2010 12:30'!
testTimestamp
	| ts buffer |
	ts := MDTimestamp now.
	buffer := SMSerializer serialize: ts.
	self assert: buffer size = 5.
	self assert: (SMMaterializer materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testTrue
	self assertIdentityOf: true! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:44'!
testTwoByteInteger
	self assertEqualityOf: 355! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 7/13/2010 16:08'!
testVersion
	self
		assertEqualityOf: self builder version
		using: [ :before :after | 
			self assert: before variant = after variant.
			self assert: before hashstamp = after hashstamp.
			self assert: before ancestry = after ancestry ]! !

TestCase subclass: #MDSerializationTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDSerializationTypeTest commentStamp: 'cwp 4/19/2008 12:04' prior: 0!
Here's the type specifications that this class enforces:

     1  object
     2  class (fixed)
     3  class (pointers)
     4  class (bytes)
     5  class (well-known)
     6  nil
     7  true
     8  false
     9  8 bit unsigned integer
    10  small positive integer
    11  small negative integer
    12  large positive integer
    13  large negative integer
    14  symbol (utf-8)
    15  string (utf-8)
    16  string (utf-16be)
    17  array
    18  set
    19  dictionary
    20  properties
    21  timestamp
    22  hashstamp
    23  hashed object!

!MDSerializationTypeTest methodsFor: 'asserting' stamp: 'cwp 9/9/2010 20:36'!
assertObject: anObject hasType: anInteger
	| bytes |
	bytes := MDSerializer serialize: anObject.
	self assert: bytes first = 242.
	self assert: bytes second = anInteger! !

!MDSerializationTypeTest methodsFor: 'running' stamp: 'cwp 11/8/2009 21:49'!
setUp
	super setUp.
	MDMaterializer initializeTypes! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test20Properties
	self
		assertObject: MDPropertyDictionary new
		hasType: 20! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test21Timestamp
	self
		assertObject: MDTimestamp now
		hasType: 21! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test22Hashstamp
	self
		assertObject: (MDHashstamp fromString: 'AbjG2m8xWqxTBPAOm0Sq4bCsci7JbfKX')
		hasType: 22! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 8/17/2010 09:58'!
test23HashedObject
	self
		assertObject: (MDSnapshot sliceId: MDHashstamp new versions: Set new)
		hasType: 23! !

TestCase subclass: #MDSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDSerializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:06'!
isAbstract
	^ self name = #MDSerializerTest! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2008 23:49'!
assert: actual equals: expected
	| limit |
	limit := actual size min: expected size.
	1 to: limit do: [:index | self assert: (actual at: index) = (expected at: index)].
	self assert: actual size = expected size! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:19'!
assert: anObject yields: expected 
	| stream actual |
	stream := ByteArray new writeStream.
	self serialize: anObject on: stream.
	actual := stream contents.
	self 
		assert: actual
		equals: expected! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 18:54'!
serialize: anObject on: aStream
	self subclassResponsibility! !

MDSerializerTest subclass: #MDUtf16SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 11:41'!
serialize: anObject on: aStream
	| serializer |
	serializer := SMSerializer on: aStream.
	serializer serializeUtf16String: anObject.! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:26'!
testAboriginal
	self 
		assert: (MDPlatform current stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[250 3 20 1 20 2 20 3]! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:26'!
testAscii
	self 
		assert: 'abc' 
		yields: #[250 3 0 97 0 98 0 99]! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:25'!
testLatin
	self 
		assert: (MDPlatform current stringFromUnicode: #(225 98 99))
		yields: #[250 3 0 225 0 98 0 99]
	! !

MDSerializerTest subclass: #MDUtf8SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Serialization'!

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 11:41'!
serialize: anObject on: aStream
	| serializer |
	serializer := SMSerializer on: aStream.
	serializer serializeUtf8String: anObject.! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:25'!
testAboriginal
	self 
		assert: (MDPlatform current stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[251 3 225 144 129 225 144 130 225 144 131]! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:24'!
testAscii
	self assert: 'abc' yields: #(251 3 97 98 99)! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:24'!
testLatin
	self 
		assert: (MDPlatform current stringFromUnicode: #(225 98 99)) 
		yields: #[251 3 195 161 98 99]! !
